#include <AltSoftSerial.h>
#include <GP3Port.h>

/* Example program for GP3 Control with Arduinio
 * Al Wiliams -- http://www.awce.com/gp3.htm
 * 
 * Example V1.0 for use with library V1.0
 */
 
/* The GP3 library uses SoftwareSerial by default so you need to include it
   However, you can initialize it with a stream if you prefer so you should
   be able to use Serial1 or AltSoftSerial, etc. 
   
   This is the original demo modified to use
   AltSoftSerial (http://www.pjrc.com/teensy/td_libs_AltSoftSerial.html)
   
*/



AltSoftSerial sport;
GP3 gp3(sport);


/* In the setup, 
   Set up the serial port for debugging messages
   Go ahead and reset the GP3 board and do a check to see if it 
   is alive.
   */
void setup() {
  sport.begin(57600);
  Serial.begin(57600); // debugging port
  gp3.resetAll();
  if (gp3.check()!=51)
    Serial.println("Oh oh. Can't find GP3!");
  
}

// This does a test conversion and times it
// It is here because we want to do it twice
// inside loop
void conversion()
{
  int v;   // a2d value
  unsigned long t0,t1;  // for timing
  t0=millis();    // time mark
  v=gp3.a2d();    // do a conversion
  t1=millis();    // done with the time
  Serial.print(v);
  Serial.print(" ");
  Serial.print((5.0/1023.0)*v);
  Serial.print("V ");
  Serial.println(t1-t0);

}


/* On each loop we are going to set the LED and 
   measure a voltage. This works out nice if you
   jumper the LED to the analog 0 input 
   
   We will also compute the time it takes to do 
   a conversion. */
void loop() {

  gp3.setLED(true);  // turn on LED
  conversion();
  delay(500);
  gp3.setLED(false);  // now turn off
  conversion();
  delay(500);
}
