#include <gp3.h>

void GP3::setarg(unsigned int arg)
{
  if (arg<=255)
    {
      port.write(6+(arg&1));
      port.write(0x80+(arg&1));
    }
  else
    {
      int code=8+(arg&1);
      port.write(code+((arg>>8)&1));
      port.write(0x80+(arg>>9));
      port.write(0x80+((arg&0xFF)>>1));
    }
}

unsigned int GP3::readWord(void)
{
  unsigned int rv;
  rv=port.read()<<8;
  return rv+port.read();
}

void GP3::setLED(boolean onoff)
{
  port.write(0xC+(onoff&1));
}

unsigned int GP3::a2d(int chan)
{
  port.write(0x30+((chan&7)<<1));
  return readWord();
}

void GP3::high(int pin)
{
  port.write(0x11+(pin<<1));
}

void GP3::low(int pin)
{
  port.write(0x10+(pin<<1));
}

void GP3::toggle(int pin)
{
  port.write(0x20+(pin<<1));
}

int GP3::input(int pin)
{
  port.write(0x21+(pin<<1));
}




